From e16d6ddbfdc4110fbbbcf763cff5a72b0f0df92c Mon Sep 17 00:00:00 2001
Message-Id: <e16d6ddbfdc4110fbbbcf763cff5a72b0f0df92c.1675376734.git.adrian@medranocalvo.com>
From: =?UTF-8?q?Adri=C3=A1n=20Medra=C3=B1o=20Calvo?=
 <adrian@medranocalvo.com>
Date: Wed, 1 Feb 2023 00:00:00 +0000
Subject: [PATCH] Fix `mouse-autoselect-window' for alternating XInput and
 XInput 2 events

* src/xterm.c (handle_one_xevent): Move `last_mouse_window' to
main function scope to share value between XInput and XInput 2
handlers.
---
 src/xterm.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/src/xterm.c b/src/xterm.c
index 6a4b84babe4..dd20c8c7fe5 100644
--- a/src/xterm.c
+++ b/src/xterm.c
@@ -18364,6 +18364,9 @@ handle_one_xevent (struct x_display_info *dpyinfo,
   GdkDisplay *gdpy = gdk_x11_lookup_xdisplay (dpyinfo->display);
 #endif
   int dx, dy;
+  /* Holds the last window the mouse moved over, used for
+     `mouse-autoselect-window' */
+  static Lisp_Object last_mouse_window;
 
   /* Avoid warnings when SAFE_ALLOCA is not actually used.  */
 #if defined HAVE_XINPUT2 || defined HAVE_XKB || defined HAVE_X_I18N
@@ -20677,8 +20680,6 @@ handle_one_xevent (struct x_display_info *dpyinfo,
 		&& (f == XFRAME (selected_frame)
 		    || !NILP (focus_follows_mouse)))
 	      {
-		static Lisp_Object last_mouse_window;
-
 		if (xmotion.window != FRAME_X_WINDOW (f))
 		  {
 		    x_translate_coordinates (f, xmotion.x_root, xmotion.y_root,
@@ -22587,7 +22588,6 @@ handle_one_xevent (struct x_display_info *dpyinfo,
 		      && (f == XFRAME (selected_frame)
 			  || !NILP (focus_follows_mouse)))
 		    {
-		      static Lisp_Object last_mouse_window;
 		      Lisp_Object window = window_from_coordinates (f, ev.x, ev.y, 0, false, false);
 
 		      /* A window will be autoselected only when it is not
-- 
2.39.1

